
Sample = [];
Sample = cell(1,1);
Countries = [];
Countries = cell(1,1);

for jj = 1:size(country_code,1)
    
    if jj < 8
        Sample(jj,1) = {'Developed Economies'};
    else
        Sample(jj,1) = {'Emerging Markets'};
    end
    
    if country_code(jj) == 1
        country = 'Australia'
    elseif country_code(jj) == 2
        country = 'Canada'
    elseif country_code(jj) == 3
        country = 'Denmark'
    elseif country_code(jj) == 4
        country = 'Norway'
    elseif country_code(jj) == 5
        country = 'NZ'
    elseif country_code(jj) == 6
        country = 'Switzerland'
    elseif country_code(jj) == 7
        country = 'Sweden'
    elseif country_code(jj) == 8
        country = 'Brazil'
    elseif country_code(jj) == 9
        country = 'Chile'
    elseif country_code(jj) == 10
        country = 'China'
    elseif country_code(jj) == 11
        country = 'Colombia'
    elseif country_code(jj) == 12
        country = 'Czechia'
    elseif country_code(jj) == 13
        country = 'HK'
    elseif country_code(jj) == 14
        country = 'Hungary'
    elseif country_code(jj) == 15
        country = 'India'
    elseif country_code(jj) == 16
        country = 'Indonesia'
    elseif country_code(jj) == 17
        country = 'Israel'
    elseif country_code(jj) == 18
        country = 'Korea'
    elseif country_code(jj) == 19
        country = 'Malaysia'
    elseif country_code(jj) == 20
        country = 'Mexico'
    elseif country_code(jj) == 21
        country = 'Peru'
    elseif country_code(jj) == 22
        country = 'Phillipines'
    elseif country_code(jj) == 23
        country = 'Poland'
    elseif country_code(jj) == 24
        country = 'Russia'
    elseif country_code(jj) == 25
        country = 'S.Africa'
    elseif country_code(jj) == 26
        country = 'Singapore'
    elseif country_code(jj) == 27
        country = 'Thailand'
    elseif country_code(jj) == 28
        country = 'Turkey'
    end
    
    Countries{jj,1} = country;
    
    %Need to reset yearlab for each country as this vector gets cut later
    yearlab = [1980:0.25:2018.25]';
    % Yearlab needs to match the size of data.foreign, data.commodities and
    % data.domestic
    
    data.commodities = xlsread('pink_sheet.xlsx','quarterly');
    data.commodities = [NaN(1,3);100*diff(log(data.commodities))];
    
    data.foreign = xlsread('Advanced_Economies.xlsx','foreign_data');
    
    %Check if emerging markets or develped economies
    if country_code(jj) < 8
        data.domestic = xlsread('Advanced_Economies.xlsx',country);
    else
        data.domestic = xlsread('Emerging_Markets.xlsx',country);
    end
    
    data.process_code_foreign = data.foreign(1,:);
    data.process_code_domestic = data.domestic(1,:);
    
    data.foreign = data.foreign(4:end,:);
    data.domestic = data.domestic(4:end,:);
    
    %% IMPORT WORLD BANK INFLATION DATA
    [~, country_txt] = xlsread('WB_data.xls','inflation_qoq_all_sa','B1:HE1');
    ind.txt = find(strcmp(country,country_txt)==1);
    
    % index 40 is 1979Q4. 194 is 2018Q2. This is to align dates
    data.Pi = xlsread('WB_data.xls','inflation_qoq_all_sa');
    data.Core = xlsread('WB_data.xls','core_inf_qoq_all_sa');
    
    data.Pi = data.Pi(40:194,ind.txt);
    data.Core = data.Core(40:194,ind.txt);
    
    data.dPi = diff(data.Pi);
    data.dCore = diff(data.Core);
    
    %take the log of the real exchange rate
    data.domestic(:,end) = 100*log(data.domestic(:,end));
    % Apply Transformations diff the log if 1, otherwise keep the level
    % (i.e. interest rate unemployment rate etc)
    for i = 1:size(data.foreign,2)
        if data.process_code_foreign(1,i) == 1
            data.foreign(:,i) = [NaN;100*diff(log(data.foreign(:,i)))];
        end
    end
    
    for i = 1:size(data.domestic,2)
        if data.process_code_domestic(1,i) == 1
            data.domestic(:,i) = [NaN;100*diff(log(data.domestic(:,i)))];
        end
    end
    
    %% Stack all the data to find the range
    if options.EC == 0
        data.X = [data.dPi data.foreign data.domestic];
    elseif options.EC == 1
        data.X = [data.dPi data.dCore data.foreign data.domestic];
    end
    
    ind.start = min(find(sum(isnan(data.X),2)==0));
    ind.end = max(find(sum(isnan(data.X),2)==0));
    
    % Cut hyper inflation episodes
    if country_code(jj) == 20 %Mexico
        ind.start_can = find(yearlab==1996.25);
        if ind.start_can > ind.start
            ind.start = ind.start_can;
        end
    elseif country_code(jj) == 28 %Turkey
        ind.start_can = find(yearlab==2003);
        if ind.start_can > ind.start
            ind.start = ind.start_can;
        end
    elseif country_code(jj) == 14 %Hungary
        ind.start_can = find(yearlab==1995.5);
        if ind.start_can > ind.start
            ind.start = ind.start_can;
        end
    elseif country_code(jj) == 11 %Colombia
        ind.start_can = find(yearlab==1992);
        if ind.start_can > ind.start
            ind.start = ind.start_can;
        end
    elseif country_code(jj) == 9 %Chile
        ind.start_can = find(yearlab==1991);
        if ind.start_can > ind.start
            ind.start = ind.start_can;
        end
    elseif country_code(jj) == 24 %Russia
        ind.start_can = find(yearlab==2000);
        if ind.start_can > ind.start
            ind.start = ind.start_can;
        end
    elseif country_code(jj) == 16 %Indonesia
        ind.start_can = find(yearlab==2006);
        if ind.start_can > ind.start
            ind.start = ind.start_can;
        end
    elseif country_code(jj) == 8 %Brazil
        ind.start_can = find(yearlab==1999);
        if ind.start_can > ind.start
            ind.start = ind.start_can;
        end
    end
    
    
    %% Cut the data
    
    yearlab = yearlab(ind.start:ind.end);
    data.foreign = data.foreign(ind.start:ind.end,:);
    data.domestic = data.domestic(ind.start:ind.end,:);
    data.dPi = data.dPi(ind.start:ind.end);
    data.dCore = data.dCore(ind.start:ind.end);
    data.Pi = data.Pi(ind.start:ind.end+1);
    data.Core = data.Core(ind.start:ind.end+1);
    data.commodities = data.commodities(ind.start:ind.end,:);
    
    %% Extract Factors
    
    % Do Break adjustment here
    % Breaks for foreign
    for ii = 1:size(data.foreign,2)
        adf= unitroot(data.foreign(:,ii));
        
        if adf(3,4)>0.05 % if not stationary
            
            % Do break adjustment here
            adj_y = supFadjustment(data.foreign(:,ii));
            adf= unitroot(adj_y);
            
            if adf(3,4) < 0.05
                data.foreign(:,ii) = adj_y;
            else
                data.foreign(:,ii) = [NaN;diff(data.foreign(:,ii))];
            end
        end
    end
    for ii = 1:size(data.domestic,2)
        adf= unitroot(data.domestic(:,ii));
        
        if adf(3,4)>0.05 % if not stationary
            
            % Do break adjustment here
            adj_y = supFadjustment(data.domestic(:,ii));
            adf= unitroot(adj_y);
            
            if adf(3,4) < 0.05
                data.domestic(:,ii) = adj_y;
            else
                data.domestic(:,ii) = [NaN;diff(data.domestic(:,ii))];
            end
        end
    end
    
    
    % Kill the first observation if its a NaN due to differencing
    if sum(isnan(data.foreign(1,:))) > 0 || sum(isnan(data.domestic(1,:))) > 0
        data.foreign = data.foreign(2:end,:);
        data.domestic = data.domestic(2:end,:);
        data.commodities = data.commodities(2:end,:);
        yearlab = yearlab(2:end,:);
        data.dPi = data.dPi(2:end,:);
        data.dCore = data.dCore(2:end,:);
        data.Core = data.Core(2:end,:);
        data.Pi = data.Pi(2:end,:);
    end
    
    [~,factors_foreign,~] = pca(zscore(data.foreign));
    [~,factors_domestic,~] = pca(zscore(data.domestic(:,1:end-1))); %final column is exchange rate
    
    % Demean both commodities and exchange rate as the GC test is without a
    % constant
    data.commodities = data.commodities-repmat(mean(data.commodities),size(yearlab,1),1);
    data.domestic(:,end) = data.domestic(:,end)-repmat(mean(data.domestic(:,end)),size(yearlab,1),1);
    
    
    %% Testing for number of factors
    
    p = 4;
    
    if strcmp(Specification,'Robustness') == 1
        nForFac = 3; nDomFac = 3;
    else
        
        % Initial Specification of one factor  each
        nForFac = 1; nDomFac = 1;
        
        if options.EC == 0
            y = [factors_domestic(:,1:nDomFac) data.domestic(:,end) data.dPi];
        elseif options.EC == 1
            y = [factors_domestic(:,1:nDomFac) data.domestic(:,end) data.dPi data.dCore];
            coint_vec = data.Pi(1:end-1,1)-data.Core(1:end-1,1);
        end
        
        p_value = 0;
        
        %Testing for domestic factors. Only test in domestic block as block
        %exogeneity means no need to test for whether domestic factor GC
        %foreign block
        while sum(p_value < options.GCTest_LOS) > 0 && nDomFac <= min(options.max_factors,size(factors_domestic,2))-1
            M = size(y,2);
            p_value = NaN(M,1);
            y_temp = [y factors_domestic(:,nDomFac+1)];
            for i = 1:M
                p_value(i,1) = granger_causality_exo(y_temp,p,[],i,M+1);
                if options.EC == 1 && i > M-2%test error correction term in inflation equations
                    p_value(i,1) = granger_causality_exo(y_temp,p,coint_vec,i,M+1);
                end
            end
            if sum(p_value < options.GCTest_LOS) > 0
                nDomFac = nDomFac + 1;
                if options.EC == 0
                    y = [factors_domestic(:,1:nDomFac) data.domestic(:,end) data.dPi];
                elseif options.EC == 1
                    y = [factors_domestic(:,1:nDomFac) data.domestic(:,end) data.dPi data.dCore];
                end
            end
        end
        
        y = [data.commodities factors_foreign(:,1) y];
        
        p_value = 0;
        %Testing size of foreign block
        while sum(p_value < options.GCTest_LOS) > 0 && nForFac <= min(options.max_factors,size(factors_foreign,2))-1
            M = size(y,2);
            p_value = NaN(M,1);
            % Testing GC only in foreign block
            y_temp = [y(:,1:nForFac+3) factors_foreign(:,nForFac+1)];
            for i = 1:nForFac+3
                p_value(i,1) = granger_causality_exo(y_temp,p,[],i,nForFac+1+3);
            end
            y_temp = [y factors_foreign(:,nForFac+1)];
            % Now test GC in domestic block
            for i = nForFac+1+3:size(y_temp,2)-1
                p_value(i,1) = granger_causality_exo(y_temp,p,[],i,size(y_temp,2));
                if options.EC == 1 && i > M-2%test error correction term in inflation equations
                    p_value(i,1) = granger_causality_exo(y_temp,p,coint_vec,i,size(y_temp,2));
                end
            end
            if sum(p_value < options.GCTest_LOS) > 0
                nForFac = nForFac + 1;
                y = [data.commodities factors_foreign(:,1:nForFac) factors_domestic(:,1:nDomFac) data.domestic(:,end) data.dPi];
                if options.EC == 1
                    y = [y data.dCore];
                end
            end
        end
    end
    
    %% ESTIMATION
    disp('Number of Factors')
    
    nForFac
    nDomFac
    
    y = [data.commodities factors_foreign(:,1:nForFac) factors_domestic(:,1:nDomFac) data.domestic(:,end)];
    
    if options.EC == 0
        
        
        M= size(y,2)+1;
        
        [BN_cycle{jj,1},BN_trend{jj,1},shock_decom{jj,1},FEVD{jj,1},MVSTNR(jj,1),taupi(jj,1),FS_STNR(jj,1)] = ...
            BN_Inflation_BFAVAR_block_exogenous_MCMC(y,data.Pi,p,lambda,nForFac+3,'DoDecomp');
        
        
    elseif options.EC == 1
        
        y_coin = [data.Core data.Pi];
        
        M = size(y,2)+2;
        
        [BN_cycle{jj,1},BN_trend{jj,1},shock_decom{jj,1},FEVD{jj,1},MVSTNR(jj,1),taupi(jj,:),FS_STNR(jj,1)] = ...
            BN_Inflation_BFAVAR_block_exogenous_MCMC(y,y_coin,p,lambda,nForFac+3,'ECTerm','DoDecomp');
    end
    
    %cell because the sample is different for different countries
    headline{jj,1} = data.Pi;
    date{jj,1} = yearlab;
    
    date_start_end(jj,1) = yearlab(1);
    date_start_end(jj,2) = yearlab(end);
    
    
    if options.EC == 1
        Core{jj,1} = data.Core;
    end
    
    %% PRINT AND SAVE STUFF
    disp('lambda')
    disp(lambda)
    
    disp('% of Foreign Shocks driving trend')
    disp(sum(FEVD{jj,1}.trend(M,1:nForFac+3)))
    
    disp('% of Foreign Shocks driving Cycle')
    disp(sum(FEVD{jj,1}.cycle(M,1:nForFac+3)))
    
    disp('Signal-to-Noise Ratio')
    disp(MVSTNR(jj))
    
    disp('Variance of Trend')
    disp(taupi(jj))
    
    disp('Foreign Shocks STNR')
    disp(FS_STNR(jj))
    
    disp('Time Elapsed')
    toc
    
    Foreign_shocks_shares(jj,:) = [sum(FEVD{jj,1}.cycle(M,1:nForFac+3)) sum(FEVD{jj,1}.trend(M,1:nForFac+3))];
    Com_shocks_shares(jj,:) = [sum(FEVD{jj,1}.cycle(M,1:3,end)) sum(FEVD{jj,1}.trend(M,1:3))];
    other_foreign_shocks_shares(jj,:) = [sum(FEVD{jj,1}.cycle(M,4:nForFac+3)) sum(FEVD{jj,1}.trend(M,4:nForFac+3))];
    
end