figure

plot_country = [2 5 11 18]';
for jj = 1:size(plot_country,1)
    subplot(2,2,jj)
    h1=plot(date{country_code(plot_country(jj)),1},headline{country_code(plot_country(jj)),1}(2:end,:),'-.r','LineWidth',2);
    hold on
    h2=plot(date{country_code(plot_country(jj)),1},BN_trend{country_code(plot_country(jj)),1},'-k','LineWidth',1.5);
    hold on
    plot([1980 2019],zeros(2,1),'-k','LineWidth',1);
    if country_code(plot_country(jj)) == 2
        yeartarget = [1991 yearlab(end)];
        target = repmat([1 3],2,1);
        shade_plots_b(yeartarget,target,0.99)
    elseif country_code(plot_country(jj)) == 5
        yeartarget = [1990.25 1991-0.001 1991 1992-0.001 1992 1993-0.001...
            1993 1997-0.01 1997 2002.7499 2002.75 yearlab(end)];
        target = [3 5;3 5;2.5 4.5;2.5 4.5;1.5 3.5;1.5 3.5;0 2;0 2;0 3;0 3;1 3;1 3];
        shade_plots_b(yeartarget,target,0.99)
    end
    title(Countries{country_code(plot_country(jj))})
    if strcmp(Countries(country_code(plot_country(jj))),'NZ')
        title('New Zealand')
    end
    grid on
    grid minor
    xlim([date{country_code(plot_country(jj)),1}(1,1) date{country_code(plot_country(jj)),1}(end,1)])
    set(gca,'FontSize',12)
    
end
legend1 = legend([h1 h2],{'Headline Inflation','Trend Inflation'},'Orientation','horizontal');
% This is to just put the legend at a nice splot at the bottom
set(legend1,'Position',[0.42 0.015 0.20 0.02],'Orientation','horizontal');


%% Plot Shares
figure % Advanced Economies
h1=barh(Foreign_shocks_shares(7:-1:1,:))
bonecolors = bone(2);
set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
grid on
grid minor
set(gca,'yticklabel',Countries(7:-1:1),'FontSize',16)
legend(h1,{'Inflation Gap','Trend Inflation'})
xlim([0 100])
%title('Benchmark')
%xlim([0.5 size(country_code,1)+0.5])

figure
for jj = 1:3
    subplot(1,3,jj)
    h1=barh(Foreign_shocks_shares(jj*7+7:-1:7+((jj-1)*7)+1,:))
    bonecolors = bone(2);
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(jj*7+7:-1:7+((jj-1)*7)+1),'FontSize',16)
    xlim([0 100])
end
legend1=legend(h1,{'Inflation Gap','Trend Inflation'},'Orientation','horizontal');
set(legend1,'Position',[0.42 0.015 0.20 0.02],'Orientation','horizontal');




for kk = 1:2
    figure
    subplot(1,4,1)
    h1=barh([Com_shocks_shares(7:-1:1,kk) other_foreign_shocks_shares(7:-1:1,kk)],'stacked');
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(7:-1:1),'FontSize',12)
    ylim([0.5 7.5])
    if kk ==1
        xlim([0 100])
    else
        xlim([0 40])
    end
    title('Developed Economies')
    xlabel('Percent')
    
    subplot(1,4,2)
    h1=barh([Com_shocks_shares(14:-1:8,kk) other_foreign_shocks_shares(14:-1:8,kk)],'stacked');
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(14:-1:8),'FontSize',12)
    ylim([0.5 7.5])
    if kk ==1
        xlim([0 100])
    else
        xlim([0 40])
    end
    title('Emerging Markets')
    xlabel('Percent')
    
    subplot(1,4,3)
    h1=barh([Com_shocks_shares(21:-1:15,kk) other_foreign_shocks_shares(21:-1:15,kk)],'stacked');
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(21:-1:15),'FontSize',12)
    ylim([0.5 7.5])
    if kk ==1
        xlim([0 100])
    else
        xlim([0 40])
    end
    title('Emerging Markets')
    xlabel('Percent')
    
    subplot(1,4,4)
    h1=barh([Com_shocks_shares(28:-1:22,kk) other_foreign_shocks_shares(28:-1:22,kk)],'stacked');
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(28:-1:22),'FontSize',12)
    ylim([0.5 7.5])
    if kk ==1
        xlim([0 100])
    else
        xlim([0 40])
    end
    title('Emerging Markets')
    xlabel('Percent')
    legend1=legend(h1,{'Commodity Price Shocks','Other Foreign Shocks'},'Orientation','horizontal');
    set(legend1,'Position',[0.42 0.015 0.20 0.02],'Orientation','horizontal');
end


%% Appendix PLOT of all countries


for jj = 1:size(country_code,1)
    subplotnum = rem(jj,7);
    if subplotnum == 0
        subplotnum = 7;
    end
    if subplotnum == 1
        figure
    end
    
    subplot(4,2,subplotnum)
    h1=plot(date{country_code(jj),1},headline{country_code(jj),1}(2:end,:),'-.r','LineWidth',2);
    hold on
    h2=plot(date{country_code(jj),1},BN_trend{country_code(jj),1},'-k','LineWidth',1.5);
    hold on
    plot([1980 2019],zeros(2,1),'-k','LineWidth',1);
    title(Countries{country_code(jj)})
    grid on
    grid minor
    xlim([date{country_code(jj),1}(1,1) date{country_code(jj),1}(end,1)])
    set(gca,'FontSize',10)
    
    if subplotnum == 7
        legend1=legend([h1 h2],{'Headline Inflation','Trend Inflation'});
        set(legend1,'Position',[0.64 0.1 0.14 0.22],'Orientation','horizontal');
    end
    
end









%% PLOT COMPARISONS
figure
subplot(1,2,1)
boxplot(MVSTNR,char(Sample))
set(gca,'FontSize',14)
title('Estimates of \delta')

subplot(1,2,2)
boxplot(FS_STNR,char(Sample))
set(gca,'FontSize',14)
title('Estimates of \delta^F')

figure
subplot(1,2,1)
boxplot(taupi,char(Sample))
set(gca,'FontSize',14)
title('var(\Delta\tau_t)')

subplot(1,2,2)
boxplot((Foreign_shocks_shares(:,2)/100).*taupi,char(Sample))
set(gca,'FontSize',14)
title('var(\Delta\tau_t\mid\epsilon_t^*)')


%% t-tests

[h pvalue_t_test1] = ttest2(MVSTNR(1:7),...
    MVSTNR(8:end),'Vartype','unequal','Tail','left');
disp('One Sided Test for \delta across both samples (p value)')
disp(pvalue_t_test1)

[h pvalue_t_test2] = ttest2(FS_STNR(1:7),...
    FS_STNR(8:end),'Vartype','unequal','Tail','left');
disp('One Sided Test for \delta^F across both samples (p value)')
disp(pvalue_t_test2)

[h pvalue_t_test3] = ttest2(taupi(1:7),...
    taupi(8:end),'Vartype','unequal','Tail','left');
disp('One Sided Test for var(\Delta\tau_t) across both samples (p value)')
disp(pvalue_t_test3)


[h pvalue_t_test4] = ttest2((Foreign_shocks_shares(1:7,2)/100).*taupi(1:7),...
    (Foreign_shocks_shares(8:end,2)/100).*taupi(8:end),'Vartype','unequal','Tail','left');
disp('One Sided Test for var(\Delta\tau_t\mid\epsilon_t^*) across both samples (p value)')
disp(pvalue_t_test4)
