
Files = {'Results\Baseline','Results\Relax_Block_Exogenous','Results\drop_stock_prices','Results\Orthogonalize_stock_prices'};
Labels = {'Baseline','Relax Block Exogeniety','Drop Stock Prices','F^*_{A,t} Block'};


figure
for jj = 1:4
    subplot(2,2,jj)
    load(Files{jj})
    boxplot(FS_STNR,char(Sample))
    set(gca,'FontSize',12)
    title(Labels{jj})
    ylim([0 5])
    [h pvalue_t_test2] = ttest2(FS_STNR(1:7),...
        FS_STNR(8:end),'Vartype','unequal','Tail','left');
    disp(['One Sided Test for \delta^F across both samples, ',Labels{jj},', (p value)'])
    disp(pvalue_t_test2)
end


%%


% Plot Developed
figure % Advanced Economies
for jj = 1:4
    subplot(1,4,jj)
    load(Files{jj})
    h1=barh(Foreign_shocks_shares(7:-1:1,:))
    bonecolors = bone(2);
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(7:-1:1),'FontSize',12)
    xlim([0 100])
    title(Labels{jj})
end
legend1=legend(h1,{'Inflation Gap','Trend Inflation'});
% This is to just put the legend at a nice splot at the bottom
set(legend1,'Position',[0.42 0.015 0.20 0.02],'Orientation','horizontal');
%Plot emerging markets


for jj = 1:3
    figure
    for ii = 1:4
        subplot(1,4,ii)
        load(Files{ii})
        h1=barh(Foreign_shocks_shares(jj*7+7:-1:7+((jj-1)*7)+1,:))
        bonecolors = bone(2);
        set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
        set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
        grid on
        grid minor
        set(gca,'yticklabel',Countries(jj*7+7:-1:7+((jj-1)*7)+1),'FontSize',12)
        xlim([0 100])
        title(Labels{ii})
        
    end
    legend1=legend(h1,{'Inflation Gap','Trend Inflation'});
    % This is to just put the legend at a nice splot at the bottom
    set(legend1,'Position',[0.42 0.015 0.20 0.02],'Orientation','horizontal');
end

% Commodity Price shocks

for kk = 1:2
    
    for jj = 1:4
        figure
        for ii = 1:4
            load(Files{ii})
            subplot(1,4,ii)
            h1=barh([Com_shocks_shares(jj*7:-1:(jj-1)*7+1,kk) other_foreign_shocks_shares(jj*7:-1:(jj-1)*7+1,kk)],'stacked');
            set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
            set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
            grid on
            grid minor
            set(gca,'yticklabel',Countries(jj*7:-1:(jj-1)*7+1),'FontSize',12)
            ylim([0.5 7.5])
            if kk ==1
                xlim([0 100])
            else
                xlim([0 40])
            end
            title(Labels{ii})
            xlabel('Percent')
        end
        legend1=legend(h1,{'Commodity Price Shocks','Other Foreign Shocks'},'Orientation','horizontal');
        % This is to just put the legend at a nice splot at the bottom
        set(legend1,'Position',[0.42 0.015 0.20 0.02],'Orientation','horizontal');
        
    end
end