bonecolors = bone(2);

%%
figure % Advanced Economies
h1=barh(Foreign_shocks_shares(7:-1:1,:))
bonecolors = bone(2);
set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
grid on
grid minor
set(gca,'yticklabel',Countries(7:-1:1),'FontSize',16)
legend(h1,{'Inflation Gap','Trend Inflation'})
xlim([0 100])
%title('Benchmark')
%xlim([0.5 size(country_code,1)+0.5])

figure
for jj = 1:2
    subplot(1,2,jj)
    h1=barh(Foreign_shocks_shares(jj*5+7:-1:7+((jj-1)*5)+1,:))
    bonecolors = bone(2);
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(jj*5+7:-1:7+((jj-1)*5)+1),'FontSize',16)
    xlim([0 100])
end
legend1 = legend(h1,{'Inflation Gap','Trend Inflation'});


%% Plot Shares

for kk = 1:2
    figure
    subplot(1,3,1)
    h1=barh([Com_shocks_shares(7:-1:1,kk) other_foreign_shocks_shares(7:-1:1,kk)],'stacked');
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(7:-1:1),'FontSize',12)
    ylim([0.5 7.5])
    if kk ==1
        xlim([0 100])
    else
        xlim([0 50])
    end
    title('Developed Economies')
    xlabel('Percent')
    
    subplot(1,3,2)
    h1=barh([Com_shocks_shares(12:-1:8,kk) other_foreign_shocks_shares(12:-1:8,kk)],'stacked');
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(12:-1:8),'FontSize',12)
    ylim([0.5 5.5])
    if kk ==1
        xlim([0 100])
    else
        xlim([0 50])
    end
    title('Emerging Markets')
    xlabel('Percent')
    
    subplot(1,3,3)
    h1=barh([Com_shocks_shares(17:-1:13,kk) other_foreign_shocks_shares(17:-1:13,kk)],'stacked');
    set(h1(1),'FaceColor',bonecolors(1,:),'EdgeColor','k','LineStyle','-')
    set(h1(2),'FaceColor',bonecolors(2,:),'EdgeColor','k','LineStyle','-')
    grid on
    grid minor
    set(gca,'yticklabel',Countries(17:-1:13),'FontSize',12)
    ylim([0.5 5.5])
    title('Emerging Markets')
    xlabel('Percent')
    legend1 = legend(h1,{'Commodity Price Shocks','Other Foreign Shocks'},'Orientation','horizontal');
    % This is to just put the legend at a nice splot at the bottom
    set(legend1,'Position',[0.42 0.015 0.20 0.02],'Orientation','horizontal');
    
    if kk ==1
        xlim([0 100])
    else
        xlim([0 50])
    end
    title('Emerging Markets')
    xlabel('Percent')
    
    if kk ==1
        xlim([0 100])
    else
        xlim([0 50])
    end
end



%% PLOT COMPARISONS
figure
subplot(1,2,1)
boxplot(MVSTNR,char(Sample))
set(gca,'FontSize',14)
title('Estimates of \delta')

subplot(1,2,2)
boxplot(FS_STNR,char(Sample))
set(gca,'FontSize',14)
title('Estimates of \delta^F')

figure
subplot(1,2,1)
boxplot(taupi,char(Sample))
set(gca,'FontSize',14)
title('var(\Delta\tau_t)')


subplot(1,2,2)
boxplot((Foreign_shocks_shares(:,2)/100).*taupi,char(Sample))
set(gca,'FontSize',14)
title('var(\Delta\tau_t\mid\epsilon_t^*)')

%% t-tests

[h pvalue_t_test1] = ttest2(MVSTNR(1:7),...
    MVSTNR(8:end),'Vartype','unequal','Tail','left');
disp('One Sided Test for \delta across both samples')
disp(pvalue_t_test1)

[h pvalue_t_test2] = ttest2(FS_STNR(1:7),...
    FS_STNR(8:end),'Vartype','unequal','Tail','left');
disp('One Sided Test for \delta^F across both samples')
disp(pvalue_t_test2)

[h pvalue_t_test3] = ttest2(taupi(1:7),...
    taupi(8:end),'Vartype','unequal','Tail','left');
disp('One Sided Test for var(\Delta\tau_t) across both samples')
disp(pvalue_t_test3)


[h pvalue_t_test4] = ttest2((Foreign_shocks_shares(1:7,2)/100).*taupi(1:7),...
    (Foreign_shocks_shares(8:end,2)/100).*taupi(8:end),'Vartype','unequal','Tail','left');
disp('One Sided Test for var(\Delta\tau_t\mid\epsilon_t^*) across both samples')
disp(pvalue_t_test4)

