function y_adj = supFadjustment(y)
% Benjamin Wong
%% October 2017
% Monash University
%
% Dates a break in mean by calculating maximum F statistic then adjusting
% time series for the break

%%
T = size(y,1);
X1 = ones(T,1);

% Calculate sum of squared residuals for no break in mean
beta = (X1'*X1)\(X1'*y);
resid_R = y - X1*beta;
SSR_R = sum(resid_R.^2);

F_stat = zeros(T,1);

for jj = 2:T
    X2 = zeros(T,1);
    X2(1:jj-1) = 1;
    
    X = [X1 X2];
    
    beta = (X'*X)\(X'*y);
    resid_UR = y - X*beta;
    SSR_UR = sum(resid_UR.^2);
    
    F_stat(jj,1) = (SSR_R-SSR_UR)/(SSR_UR/(T-2));
end

% Get maximum F statistic but trim 15%
sup_F = max(F_stat(ceil(0.15*T):floor(0.85*T),:));

break_index = find(F_stat == sup_F);

%Rerun regression to get residuals
X2 = zeros(T,1);
X2(1:break_index-1) = 1;
X = [X1 X2]; beta = (X'*X)\(X'*y);

y_adj = y - X*beta;

end